; This is a simple example assembly lanugage program for the HC11
;

; ***************
; *   EQUATES   *
; ***************
REGBS   =  0x1000      ; start of registers

BAUD    = REGBS+0x2B  ; sci baud reg
SCCR1   = REGBS+0x2C  ; sci control1 reg
SCCR2   = REGBS+0x2D  ; sci control2 reg
SCSR    = REGBS+0x2E  ; sci status reg
SCDAT   = REGBS+0x2F  ; sci data reg
COPRST  = REGBS+0x3A  ; cop reset reg

EOT     = 0x04   ; end of text/table

        .sect    .data
dat1:   .word 0xFFFF

        .sect    .text
        .globl   _start

_start:
;        lds      #_stack ; set stack pointer, DO NOT set when running under monitor

          jsr ONSCI	 ; initialize serial port
          ldx #MSG	 ; get message string
          jsr OUTSTRG ; send it out serial port

;eloop:   nop		; endless loop
;         bra	eloop

  rts

; **********
; *   ONSCI() - Initialize the SCI for 9600
; *                 baud at 8 MHz Extal.
; **********
ONSCI:   ldaa #0x30
         staa BAUD        ; baud register
         ldaa #0x00
         staa SCCR1
         ldaa #0x0C
         staa SCCR2       ; enable
         rts

; **********
; *  OUTSTRG(x) - Output string of ASCII bytes
; * starting at x until end of text ($04).
; **********
OUTSTRG:  JSR  OUTCRLF
OUTSTRG0: PSHA
OUTSTRG1: LDAA 0,X          ; read char into a
          CMPA #EOT
          BEQ  OUTSTRG3     ; jump if eot
          JSR  OUTPUT       ; output character
          INX               ; incriment pointer
          BRA  OUTSTRG1     ; loop
OUTSTRG3: PULA
          RTS

; **********
; *  OUTCRLF() - Output a Carriage return and
; * a line feed.  Returns a = cr.
; **********
OUTCRLF:  LDAA #0x0D     ; cr
          JSR  OUTPUT    ; output a
          LDAA #0x00
          JSR  OUTPUT    ; output padding
          LDAA #0x0D
          RTS

; **********
; *  OUTPUT() - Output A to sci.
; **********
OUTPUT:
OUTSCI2:  LDAB SCSR        ; read status
          BITB #0x80
          BEQ  OUTSCI2     ; loop until tdre=1
          ANDA #0x7F       ; mask parity
          STAA SCDAT       ; send character
OUTSCI3:  RTS


; *** TEXT TABLES ***

MSG:    .ascii  "Hello World"
         fcb   EOT

;        .org 0xFFFE
;        .word  _start

;        org     $FFFE       ;  set the reset vector
;*        fdb     START



